Subject: bug#63588: 29.x: dotimes (possible) problem

From: Drew Adams <[email-masked]>
Date: Fri, 19 May 2023 15:42:36 +0000

> changing the value of the loop variable in the body of
> dotimes does not seem to have any effect, where for versions <29.x it
> used to.
...
> The ability to jump out of the loop by pushing the loop variable over
> the upper limit is something that I happen to use in my scripts, so
> 29.x breaks them somehow
> 
> Of course, there are very many other equivalent ways to
> accomplish the same result, but I don't see why this one
> shouldn't be supported (any longer)
> 
> Is the changed behavior intentional? Am I missing some blatant point here?
> 
> AFAICS, changing the value of the loop variable from inside the loop
> body is supported by any other language which I know about

No, it's not.

>From CLTL2 [*]:

  "Altering the value of var in the body of the loop
   (by using setq, for example) will have unpredictable,
   possibly implementation-dependent results. A Common
   Lisp compiler may choose to issue a warning if such
   a variable appears in a setq."

That allows an implementation of CL to define some
particular behavior in this regard.  But it also says
that if it does, and if your CL code depends on that
behavior, then it won't necessarily be portable to
other CL implementations.

It's unfortunate that if this Elisp change isn't
backward compatible.  That's indeed a consideration.
But it's wise for your code not to depend on being
able to change the loop variable and get any
meaningful resulting behavior.

Both in CL and Elisp `dotimes' lets you use RETURN
to break out of the loop.  That should speak to one
of your use cases, at least.

(dotimes (ii  100  "*********")
  (when (= 4 ii) (return "4444444444")))

CLTL2 says this:

  "An explicit return statement may be used to
   terminate the loop and return a specified value."

But I don't see where this is documented for Elisp.
Maybe it is documented somewhere.  Should be.
___

[*] https://www.cs.cmu.edu/Groups/AI/html/cltl/clm/node89.html